import { jsxs as c, jsx as s } from "react/jsx-runtime";
import { useState as D, useMemo as d, useCallback as B, useEffect as Z, Fragment as F } from "react";
import { V as ee } from "../tools/constants.js";
import { S as te } from "../tools/enums.js";
import { k, l as $, n as se, c as ae, f as ne, a as oe, p as A, b as r, i as le } from "../tools/tools.js";
import { u as ie, a as re, b as ce, c as de, F as pe, s as ue } from "../vendor.js";
import { s as v } from "./select-multiple.module.js";
const me = function(j) {
  const {
    as: R = "div",
    dropOldClass: b,
    variables: C,
    className: x,
    style: y,
    disabled: p,
    single: u,
    hideActiveOptions: V,
    placeholder: O,
    options: E,
    selectableCount: m,
    contentClasses: S,
    onChange: f,
    ..._
  } = j, H = (E ?? []).map((e, t) => ({
    ...e,
    id: e.id ?? t
  })), L = k(S, ["optionItem", "selectButton"], !0), W = k(S, ["optionItem", "selectButton"]), [N, q] = D(!1), [o, z] = D(H), { refs: w, floatingStyles: G, context: M } = ie({
    open: N,
    onOpenChange: q,
    middleware: [
      ue({
        apply({ rects: e, availableHeight: t, elements: n }) {
          Object.assign(n.floating.style, {
            minWidth: `${e.reference.width}px`,
            maxHeight: `${Math.max(0, t)}px`
          });
        }
      })
    ]
  }), K = re(M, {
    enabled: !p
  }), T = ce(M), { getReferenceProps: U, getFloatingProps: X } = de([K, T]), J = d(() => o.some((e) => $(e.header, !0)), [o]), I = d(() => se(o, "header"), [o]), i = d(() => {
    if (u) {
      const e = o.find((t) => t.active);
      return e ? [e] : [];
    } else
      return o.filter((e) => e.active);
  }, [o, u]), P = d(() => i.length, [i.length]), g = B(
    (e) => {
      z((t) => t.map((n, l) => ({
        ...n,
        active: u ? l === e : l === e ? !n.active : n.active
      })));
    },
    [u]
  ), Q = B(
    (e) => {
      const t = o.findIndex((n) => n.id === e.id);
      t !== -1 && g(t);
    },
    [g, o]
  ), Y = d(() => {
    const e = ae(
      !b && `form-select ${v.brlSelectMultipleMinHeight}`,
      p && "bg-body-secondary",
      x
    ), t = {
      ...ne(C, (n, l) => {
        const h = te[l];
        return {
          include: !0,
          transformedKey: h ? l : `${ee}${h}`
        };
      }),
      ...y
    };
    return oe(
      {
        className: e,
        style: t,
        tabIndex: p ? void 0 : 0
      },
      le
    );
  }, [b, p, x, C, y]);
  Z(() => {
    f == null || f(
      i.filter((e) => $(e.value)).map((e) => e.value)
    );
  }, [i, f]);
  const a = A(L, {
    mainContainer: r(
      null,
      typeof m == "number" && "d-flex flex-wrap justify-content-between gap-2"
    ),
    optionsContainer: "d-flex flex-wrap column-gap-2 row-gap-1",
    placeholder: "text-secondary user-select-none",
    activeOption: r(
      null,
      "d-flex align-items-center badge text-bg-secondary",
      v.brlSelectMultipleCursorDefault
    ),
    clearIcon: r(null, "bi bi-x", v.brlSelectMultipleCursorPointer),
    countDisplay: r(
      null,
      "align-self-center flex-shrink-0 text-secondary",
      v.brlSelectMultipleScale75
    ),
    floatingMenu: "overflow-y-auto dropdown-menu rounded-3 shadow show",
    header: "dropdown-header",
    topDivider: "dropdown-divider",
    bottomDivider: "dropdown-divider"
  });
  return /* @__PURE__ */ c(R, { ...U(), ..._, ...Y, ref: w.setReference, children: [
    /* @__PURE__ */ c("div", { "data-slot-main-container": "", className: a.mainContainer, children: [
      /* @__PURE__ */ s("div", { "data-slot-options-container": "", className: a.optionsContainer, children: O && i.length === 0 ? /* @__PURE__ */ s("div", { "data-slot-placeholder": "", className: a.placeholder, children: O }) : i.map((e) => /* @__PURE__ */ c("div", { "data-slot-active-option": "", className: a.activeOption, children: [
        e.text,
        /* @__PURE__ */ s(
          "i",
          {
            "data-slot-clear-icon": "",
            tabIndex: -1,
            className: a.clearIcon,
            onClick: (t) => {
              t.stopPropagation(), Q(e);
            }
          }
        )
      ] }, e.id)) }),
      typeof m == "number" && /* @__PURE__ */ s(
        "div",
        {
          "data-slot-count-display": "",
          className: a.countDisplay,
          children: `${P} / ${m}`
        }
      )
    ] }),
    N && /* @__PURE__ */ s(pe, { children: /* @__PURE__ */ s(
      "ul",
      {
        "data-slot-floating-menu": "",
        ref: w.setFloating,
        ...X(),
        className: a.floatingMenu,
        style: G,
        children: I.keys.map((e) => /* @__PURE__ */ c(F, { children: [
          J && /* @__PURE__ */ s("li", { children: /* @__PURE__ */ s("h6", { "data-slot-header": "", className: a.header, children: e }) }, e),
          I.groupedData[e].map(({ item: t, index: n }) => {
            const l = A(W, {
              optionItem: r(null, t.active && V && "visually-hidden"),
              selectButton: r(
                null,
                "dropdown-item",
                t.active && "active",
                (t.disabled || m === P) && "disabled"
              )
            });
            return /* @__PURE__ */ c(F, { children: [
              t.divider === "top" && /* @__PURE__ */ s("li", { children: /* @__PURE__ */ s("hr", { "data-slot-top-divider": "", className: a.topDivider }) }),
              /* @__PURE__ */ s("li", { "data-slot-option-item": "", className: l.optionItem, children: /* @__PURE__ */ s(
                "button",
                {
                  "data-slot-select-button": "",
                  onClick: (h) => {
                    h.stopPropagation(), g(n);
                  },
                  className: l.selectButton,
                  type: "button",
                  children: t.text
                }
              ) }),
              t.divider === "bottom" && /* @__PURE__ */ s("li", { children: /* @__PURE__ */ s("hr", { "data-slot-bottom-divider": "", className: a.bottomDivider }) })
            ] }, t.id);
          })
        ] }, e))
      }
    ) })
  ] });
};
me.displayName = "BRL.SelectMultiple";
export {
  me as S
};
